unit ENCMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ENCConst, SPIENC, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CheckBox1: TCheckBox;
    Button3: TButton;
    OpenDialog1: TOpenDialog;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  Debug: File of Byte;
  Paket: array[0..8195] of Byte;
  amrreplay: array[0..60] of Byte =($0F,{Komplet, mit Padding und CRC bertragen}
                                     $FF,$FF,$FF,$FF,$FF,$FF, {Mac vom Request}
                                     $52,$2D,$54,$72,$6F,$6E,
                                     $08,$06,$00,$01,$08,$00,
                                     $06,$04,$00,$02,
                                     $52,$2D,$54,$72,$6F,$6E,
                                     $C0,$A8,$AD,$FA,
                                     $00,$00,$00,$00,$00,$00, {Mac vom Request}
                                     $00,$00,$00,$00, {IP vom Request}
                                     $FF,$FF,$FF,$FF,$FF,$FF, {Purrge $FF}
                                     $FF,$FF,$FF,$FF,$FF,$FF,
                                     $FF,$FF,$FF,$FF,$FF,$FF);
  p3 :word = 1001;
  p4 :word = 2;
  nps:word;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 Form1.Button1.Caption:='Version '+inttostr(ENC_RCR(N_EREVID));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
buffer, npl, nph :byte;
p1,p2 :word;
begin
  Form1.CheckBox1.Checked:=True;
  ENC_WCR(N_ERXSTL,$00);ENC_WCR(N_ERXSTH,$00); {Start Lesepuffer}
  ENC_WCR(N_ERXNDL,$FF);ENC_WCR(N_ERXNDH,$17); {Ende Lesepuffer}
  ENC_WCR(N_ERXRDPTL,$00);ENC_WCR(N_ERXRDPTH,$00); {Lesepointer Merker}
  ENC_WCR(N_ERDPTL,$00);ENC_WCR(N_ERDPTH,$00); {Lesepointer}
  ENC_BFS(N_ECON2,N_AUTOINC); {Hostpointer automatisch incrementieren}
  ENC_BFC(N_MACON2,N_MARST); {MAC-Reset beenden};
  ENC_BFS(N_MACON1,N_MARXEN); {Empfnfer Disabel};
  ENC_WCR(N_MAMXFLL,$EE);ENC_WCR(N_MAMXFLH,$05); {Maximale Framelnge}
  ENC_WCR(N_MABBIPG,$12);{Back-to-Back Inter-Packet Gab}
  ENC_WCR(N_MAIPGL,$12);ENC_WCR(N_MAIPGH,$0C); {Non-Back-to-Back Inter-Packet Gab}
  {AMR Replay vorbereiten}
  ENC_WCR(N_EWRPTL,$BC);ENC_WCR(N_EWRPTH,$1F); {Start Lesepuffer}
  ENC_OpenWBM;
  for p1:=0 to 60 do ENCOut(amrreplay[p1]);
  ENCComp;

  ENC_BFS(N_ECON1,N_RXEN);{Empfnger Starten}
  ENC_BFS(N_EIE,N_PKTIE+N_INTIE);{Interrupt Freigeben}
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 ENCStart
end;

procedure TForm1.Button3Click(Sender: TObject);
var
buffer, npl, nph :byte;
p1,p2 :word;
begin
 Form1.OpenDialog1.Execute;
 AssignFile(Debug, Form1.OpenDialog1.FileName);
 reset(Debug);
 ENC_BFS(N_ECON2,N_AUTOINC); {Lesepointer automatisch incrementieren}
 ENC_WCR(N_EWRPTL,$00);ENC_WCR(N_EWRPTH,$18); {Start Lesepuffer}
 ENC_OpenWBM;
 p1:=0;
      while not Eof(Debug) do
      begin
        read(Debug, buffer);
        Paket[p1]:=buffer;
        ENCOut(buffer);
        inc(p1);
      end;
 ENCComp;
 {ENC_WCR(N_EDMASTL,20);ENC_WCR(N_EDMASTH,$18);
 ENC_WCR(N_EDMANDL,19+20);ENC_WCR(N_EDMANDH,$18);}
 ENC_WCR(N_EDMASTL,32);ENC_WCR(N_EDMASTH,$18);
 ENC_WCR(N_EDMANDL,19+Paket[23]);ENC_WCR(N_EDMANDH,$18);
 ENC_BFS(N_ECON1,N_CSUMEN+N_DMAST);
 repeat until (ENC_RCR(N_ECON1) and N_DMAST)=0;
 Form1.Button3.Caption:=inttostr(ENC_RCR(N_EDMACSH))+' '+inttostr(ENC_RCR(N_EDMACSL));
 CloseFile(Debug);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  buffer, npl, nph, dsl, dsh, del, deh :byte;
  p1,p2,z1,aps :word;
begin
ENCPoll;
Form1.CheckBox2.Checked:=ENC_INT;
Form1.CheckBox3.Checked:=ENC_WOL;
If ENC_INT then Begin
 ENC_BFC(N_EIE,N_INTIE);{Interrupt besttigen}
 buffer:=ENC_RCR(N_EIR);{Auslser lesen}
 {Form1.CheckBox2.Checked:=ENC_INT;}
 ENC_BFS(N_EIE,N_INTIE);{Interrupt freigeben}

 If (buffer and N_PKTIF)=N_PKTIF then begin
    Form1.Button2.Caption:=inttostr(ENC_RCR(N_EPKTCNT));
 repeat
  AssignFile(Debug, 'C:\ETH\Paket'+inttostr(p3)+'.bin');
  Rewrite(Debug);
  IF p4=2 then begin
     ENC_WCR(N_ERDPTL,$00);ENC_WCR(N_ERDPTH,$00); {Lesepointer}
  end;
  ENC_OpenRBM;

  npl:=ENCIn;
  Write(Debug,npl);
  p1:=npl;
  nph:=ENCIn;
  Write(Debug,nph);
  nps:=p1+256*nph; {Pointer auf nchstes Paket}
  if p4>nps then p1:=nps+$17FF else p1:=nps-1;
  z1:=2;
  for p2:=p4 to p1 do begin
      IF p2=$1800 then begin
         ENCComp;
         ENC_WCR(N_ERDPTL,$00);ENC_WCR(N_ERDPTH,$00); {Lesepointer}
         ENC_OpenRBM;
      end;
      buffer:=ENCIn;
      paket[z1]:=buffer;inc(z1);
      Write(Debug,buffer);
      end;
  ENCComp;
  CloseFile(Debug);
  If (paket[$12]=$08) and (paket[$13]=$06) then begin {AMR-Paket Request}
     p1:=p4+26; if p1>=$1800 then p1:=p1-$1800;
     p2:=p4+31; if p1>=$1800 then p1:=p1-$1800;
     ENC_WCR(N_EDMASTL,p1 mod 256);ENC_WCR(N_EDMASTH,p1 div 256);
     ENC_WCR(N_EDMANDL,p2 mod 256);ENC_WCR(N_EDMANDH,p2 div 256);
     ENC_WCR(N_EDMADSTL,$BD);ENC_WCR(N_EDMADSTH,$1F);
     ENC_BFC(N_ECON1,N_CSUMEN);
     ENC_BFS(N_ECON1,N_DMAST);
     repeat until (ENC_RCR(N_ECON1) and N_DMAST)=0;
     p2:=p4+35; if p1>=$1800 then p1:=p1-$1800;
     ENC_WCR(N_EDMANDL,p2 mod 256);ENC_WCR(N_EDMANDH,p2 div 256);
     ENC_WCR(N_EDMADSTL,$BD+32);
     ENC_BFS(N_ECON1,N_DMAST);

     ENC_WCR(N_ETXSTL,$BC);ENC_WCR(N_ETXSTH,$1F); {Start TXpuffer}
     ENC_WCR(N_ETXNDL,$F8);ENC_WCR(N_ETXNDH,$1F); {Ende TXpuffer}
     ENC_BFS(N_ECON1,N_TXRTS);

     dsl:=ENC_RCR(N_ERDPTL); dsh:=ENC_RCR(N_ERDPTH);

     ENC_WCR(N_ERDPTL,$BC);ENC_WCR(N_ERDPTH,$1F); {Lesepointer}
     AssignFile(Debug, 'C:\ETH\Amr-Paket.bin');
     Rewrite(Debug);
     ENC_OpenRBM;
     For p1:=0 to 67 do begin
         buffer:=ENCIn;
         Write(Debug,buffer); end;
     ENCComp;
     CloseFile(Debug);
     ENC_WCR(N_ERDPTL,dsl);ENC_WCR(N_ERDPTH,dsh); {Lesepointer}

  end;

  ENC_WCR(N_ERXRDPTL,npl);ENC_WCR(N_ERXRDPTH,nph); {Lesepointer Merker}
  ENC_BFS(N_ECON2,N_PKTDEC);
  inc(p3);p4:=nps+2;
until ENC_RCR(N_EPKTCNT)=0;
end;
end;

end;

end.
